/*-
 * Copyright (C)2003 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2003 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: copyarray.c,v 1.3 2004/11/20 22:05:10 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <err.h>
#include <babolo/BLINflag.h>
#include "getCGIparm.h"

int
getCGIparmarray( u_int32_t flags
    , const u_char ** args
    , const u_char * const tofind
    , const u_char * const query_delimit
    , const u_char * const null_sign
    , int dout
    ) {
    u_char *p, *f1;
    int i, ex = EX_OK;
    const u_char *empty = "";
    int out;
    FILE *outf;

    if  ((out = dup(dout)) < 0) {
        ifBLIN_QV1(flags) warn("Can\'t dup out file in getCGIparmarray");
        return(-1);
    }
    if  (!(outf = fdopen(out, "a"))) {
        ifBLIN_QV1(flags) warn("Can\'t open out file in getCGIparmarray");
        return(-1);
    }
    ifBLIN_QV3(flags)
        fprintf( stderr
               , "AR flags=%06X, tofind=%s~, query_delimit=%s~, null_sign=%s~\n"
               , flags
               , tofind ? tofind : empty
               , query_delimit
               , null_sign
               );
    f1 = NULL;

    for (i = 0; !ex && args && args[i]; i++) {
        f1 = NULL;
        p = args[i];
        ifBLIN_QV4(flags) fprintf(stderr, "p=%s~\n", p);
        f1 = p;
        if  (!(ex = getCGIparmpass2(flags, tofind, p)) && ~flags & gCGI_OTST) {
            if  ((ex = getCGIparmpass3(flags, "copy", &p))) break;
            fprintf(outf, "%d%s", i, query_delimit);
            if  (flags & gCGI_RNUM) fprintf(outf, "%s%s", null_sign, query_delimit);
            fprintf(outf, "%s\n", p);
            if  (p && p != f1) {
                free(p);
                p = NULL;
    }   }   }
    if  (p && f1 && p != f1) free(p);
    if  (!ex) fprintf(outf, "\\.\n");
    ifBLIN_QV3(flags) fprintf(stderr, "AR ex=%d\n", ex);
    fclose(outf);
    return(ex);
}
